# Sam 3 1 · Image API

> การแบ่งส่วนภาพด้วย SAM 3.1 จากพรอมต์ข้อความ จุด หรือกรอบ โดยส่งคืนภาพหน้ากาก

แบ่งส่วนภาพหนึ่งภาพด้วย SAM 3.1 โดยใช้ข้อความ `prompt`, `point_prompts` หรือ `box_prompts` สามารถจัดกลุ่มหลายกรอบต่อวัตถุได้ด้วย object_id `return_multiple_masks` ส่งคืนหน้ากากได้สูงสุด `max_masks` (1 ถึง 32) พร้อมคะแนนและกรอบครอบแบบเลือกได้ รูปแบบเอาต์พุตคือ jpeg, png หรือ webp

- Model id: `sam-3-1/image`
- Made by: Meta
- Category: Image Editing
- Output: image
- Estimated price per run: $0.01 / run (cheapest run $0.01 (10 API credits))
- Run: `POST https://api.doitong.ru/v1/run/sam-3-1/image`
- Quote: `POST https://api.doitong.ru/v1/quote/sam-3-1/image`
- Docs page: https://doitong.com/th/developers/models/sam-3-1/image

## Pricing

Price: **$0.01 / run**. Estimated from the typical cost of one run. The quote is exactly what the run charges.

The full example input below costs $0.01 = 10 API credits (1 request × 10 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.ru/v1/quote/sam-3-1/image` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `image_url` | `image` | string (image URL) | yes |  |  | URL ที่ชี้ไปยังรูปภาพสำหรับการแบ่งส่วน |
| `prompt` |  | string | no | `wheel` |  | คำสั่งข้อความสำหรับกำกับการแบ่งส่วน |
| `point_prompts` |  | array of object {x, y, label, object_id, frame_index} | no | `[]` |  | คอลเลกชันของพรอมต์แบบจุด |
| `point_prompts[].x` |  | integer \| null | no |  |  | ตำแหน่งพรอมต์ตามแกน X |
| `point_prompts[].y` |  | integer \| null | no |  |  | ตำแหน่งพรอมต์ตามแกน Y |
| `point_prompts[].label` |  | enum (integer) \| null | no |  | `0`, `1` | ป้ายกำกับพื้นหน้า/พื้นหลัง: 1 หมายถึงพื้นหน้า และ 0 หมายถึงพื้นหลัง |
| `point_prompts[].object_id` |  | integer \| null | no |  |  | ตัวระบุเสริมสำหรับจัดกลุ่มพรอมต์ที่ปรับปรุงวัตถุเดียวกัน หากระบุข้อความเป็นพรอมต์ด้วย ตัวระบุนี้จะกำหนดว่าจุดเหล่านั้นปรับปรุงวัตถุที่ตรวจพบใด |
| `point_prompts[].frame_index` |  | integer \| null | no |  |  | ดัชนีที่ระบุเฟรมสำหรับการโต้ตอบ |
| `box_prompts` |  | array of object {x_min, y_min, x_max, y_max, object_id, frame_index} | no | `[]` |  | พรอมต์แบบกรอบที่ object_id ใช้กำหนดการจัดกลุ่ม ID ที่ตรงกันจะเชื่อมโยงกรอบเข้ากับวัตถุเดียวกัน ส่วน ID ว่างจะแทนวัตถุแยกกัน สามารถระบุหลายกรอบได้ โดยแต่ละกรอบใช้พิกัด (x_min, y_min, x_max, y_max) |
| `box_prompts[].x_min` |  | integer \| null | no |  |  | พิกัด x ต่ำสุดสำหรับกรอบ |
| `box_prompts[].y_min` |  | integer \| null | no |  |  | พิกัด y ต่ำสุดสำหรับกรอบ |
| `box_prompts[].x_max` |  | integer \| null | no |  |  | พิกัด X สูงสุดของกรอบ |
| `box_prompts[].y_max` |  | integer \| null | no |  |  | พิกัด Y สูงสุดของกรอบ |
| `box_prompts[].object_id` |  | integer \| null | no |  |  | ตัวระบุเสริมสำหรับจัดกลุ่มกรอบที่ปรับปรุงวัตถุเดียวกัน |
| `box_prompts[].frame_index` |  | integer \| null | no |  |  | ดัชนีที่ระบุเฟรมสำหรับการโต้ตอบ |
| `apply_mask` |  | boolean | no | `true` |  | ควบคุมว่าจะใช้มาสก์กับรูปภาพหรือไม่ |
| `output_format` |  | enum (string) | no | `png` | `jpeg`, `png`, `webp` | รูปแบบไฟล์ของรูปภาพผลลัพธ์ |
| `return_multiple_masks` |  | boolean | no | `false` |  | ตัวเลือกการส่งคืนหลายมาสก์: เมื่อเปิดใช้ ระบบจะใช้ `max_masks` เพื่อกำหนดจำนวนมาสก์ที่สร้างและอัปโหลดเพื่อรวมไว้ใน response |
| `max_masks` |  | integer | no | `3` | 1 – 32 | ขีดจำกัดสูงสุดของมาสก์ที่ส่งคืนเมื่อเปิดใช้ `return_multiple_masks` |
| `include_scores` |  | boolean | no | `false` |  | ควบคุมการรวมคะแนนความมั่นใจสำหรับมาสก์ |
| `include_boxes` |  | boolean | no | `false` |  | ควบคุมการรวมกรอบล้อมรอบสำหรับแต่ละมาสก์ หากมี |

File parameters (`image`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{
  "image": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
}
```

A fuller example:

```json
{
  "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.ru/v1/run/sam-3-1/image?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.ru/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.ru/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/sam-3-1/image?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.ru/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/sam-3-1/image", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.ru/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "sam-3-1/image",
      "input": {
        "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "sam-3-1/image",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 10,
    "usd": "0.01",
    "charged": 10,
    "refunded": 0
  },
  "input": {
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  },
  "output": {
    "image": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200,
      "width": 1024,
      "height": 768
    },
    "masks": [
      {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200,
        "width": 1024,
        "height": 768
      }
    ],
    "metadata": [
      {
        "index": 1,
        "score": 1.0,
        "box": [
          1.0
        ]
      }
    ],
    "scores": [
      1.0
    ],
    "boxes": [
      [
        1.0
      ]
    ]
  },
  "outputs": [
    {
      "type": "image",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "width": 1024,
      "height": 768,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `image` | object {url, content_type, file_name, file_size, width, height} \| null | ภาพตัวอย่างที่แสดงมาสก์การแบ่งส่วนหลัก |
| `masks` | array of object {url, content_type, file_name, file_size, width, height} | รูปภาพที่มีมาสก์การแบ่งส่วน |
| `metadata` | array of object {index, score, box} \| null | ข้อมูลเมตาสำหรับแต่ละมาสก์ รวมถึงคะแนนและกรอบ |
| `scores` | array of number \| null | คะแนนความมั่นใจของแต่ละมาสก์ ซึ่งระบุเมื่อมีการร้องขอ |
| `boxes` | array of array of number \| null | กรอบที่ปรับมาตรฐานแล้วสำหรับแต่ละมาสก์ ในรูปแบบ [cx, cy, w, h] หากมีการร้องขอ |

## Related models

- [Sam 3 1 · Image RLE](https://doitong.com/developers/models/sam-3-1/image-rle.md) (`sam-3-1/image-rle`): $0.01 / run
- [Sam 3 1 · Video](https://doitong.com/developers/models/sam-3-1/video.md) (`sam-3-1/video`): $0.01 / 16 frames of input video
- [Sam 3 1 · Video RLE](https://doitong.com/developers/models/sam-3-1/video-rle.md) (`sam-3-1/video-rle`): $0.01 / 16 frames of input video
- [FLUX.1 Kontext \[pro\]](https://doitong.com/developers/models/flux-pro/kontext.md) (`flux-pro/kontext`): $0.04 / image
- [GPT Image 2.5 Edit](https://doitong.com/developers/models/openai/gpt-image-2.5/flare/edit.md) (`openai/gpt-image-2.5/flare/edit`): from $0.12 / image
- [Nano Banana 2 Edit](https://doitong.com/developers/models/nano-banana-2/edit.md) (`nano-banana-2/edit`): from $0.06 / image
- [Nano Banana Pro Edit](https://doitong.com/developers/models/nano-banana-pro/edit.md) (`nano-banana-pro/edit`): from $0.15 / image
- [Qwen Image 3 Edit](https://doitong.com/developers/models/alibaba/qwen-image-3/edit.md) (`alibaba/qwen-image-3/edit`): from $0.04 / image

## Links

- HTML page: https://doitong.com/developers/models/sam-3-1/image
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=sam-3-1/image
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.ru/v1/models/sam-3-1/image
